*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\GradMenu\\HB_FUNC.PRG
*+
*+    Copyright(C) 1983-2021 by Auge & Ohr
*+
*+    Functions: Procedure MAIN()
*+               Procedure PrepMenu()
*+
*+    Reformatted by Click! 2.05.38 on Sep-3-2021 at  6:34 am
*+
*+--------------------------------------------------------------------
#pragma BEGINDUMP
#include "HMG_UNICODE.h"

#include <windows.h>
#include <commctrl.h>
#include "hbapi.h"
#include <math.h>

HBRUSH LinearGradientBrush(HDC hDC, INT nWidth, INT nHeight, COLORREF Color1, COLORREF Color2, INT nDirection)
{
  INT     R1, G1, B1, R2, G2, B2;
  HDC     hDCComp;
  HBITMAP hBitmap;
  HBRUSH  hBrush, hBrushPat;
  RECT    rcF;
  INT     nCount;
  INT     i;

  R1 = GetRValue(Color1);
  G1 = GetGValue(Color1);
  B1 = GetBValue(Color1);
  R2 = GetRValue(Color2);
  G2 = GetGValue(Color2);
  B2 = GetBValue(Color2);

  hDCComp = CreateCompatibleDC(hDC);
  {
    hBitmap = CreateCompatibleBitmap(hDC, nWidth, nHeight);

    SelectObject(hDCComp, hBitmap);

    rcF.right  = nWidth;
    rcF.bottom = nHeight;

    if (nDirection == 0)
    {
      rcF.left = 0;

      for (i = 0; i < nHeight; i++)
      {
        rcF.top = i;
        hBrush  = CreateSolidBrush(RGB(R1 + (i * (R2 - R1) / nHeight), G1 + (i * (G2 - G1) / nHeight), B1 + (i * (B2 - B1) / nHeight)));
        FillRect(hDCComp, &rcF, hBrush);
        DeleteObject(hBrush);
      }
    }
    else if (nDirection == 1)
    {
      rcF.top = 0;

      for (i = 0; i < nWidth; i++)
      {
        rcF.left = i;
        hBrush   = CreateSolidBrush(RGB(R1 + (i * (R2 - R1) / nWidth), G1 + (i * (G2 - G1) / nWidth), B1 + (i * (B2 - B1) / nWidth)));
        FillRect(hDCComp, &rcF, hBrush);
        DeleteObject(hBrush);
      }
    }
    else
    {
      rcF.left = 0;
      rcF.top  = 0;
      nCount   = ceil(((nWidth > nHeight) ? nHeight : nWidth) / 2);

      for (i = 0; i < nCount; i++)
      {
        hBrush = CreateSolidBrush(RGB(R1 + (i * (R2 - R1) / nCount), G1 + (i * (G2 - G1) / nCount), B1 + (i * (B2 - B1) / nCount)));
        FillRect(hDCComp, &rcF, hBrush);
        DeleteObject(hBrush);

        ++rcF.left;
        ++rcF.top;
        --rcF.right;
        --rcF.bottom;
      }
    }
  }

  hBrushPat = CreatePatternBrush(hBitmap);

  DeleteDC(hDCComp);
  DeleteObject(hBitmap);

  return hBrushPat;
}

//        SetMenuBkGradient(hWnd, lSubMenu, RGB1, RGB2, nDirection, Wide, Height)
HB_FUNC ( SETMENUBKGRADIENT )
{
   HMENU      iMenu ;
   MENUINFO   iMenuInfo ;
   HBRUSH     hBrush ;

   HWND  hWnd     = (HWND) HMG_parnl (1);
   BOOL  lSubMenu = (BOOL) hb_parl   (2);
   INT   nWide    = (INT)  hb_parnl  (6);
   INT   nHeight  = (INT)  hb_parnl  (7);

//  hBrush = CreateSolidBrush( RGB( hb_parvni( 3, 1 ), hb_parvni( 3, 2 ), hb_parvni( 3, 3 ) ) );
   hBrush = LinearGradientBrush( GetDC(hWnd), nWide, nHeight,  RGB( hb_parvni( 3, 1 ), hb_parvni( 3, 2 ), hb_parvni( 3, 3 ) ) , RGB( hb_parvni( 4, 1 ), hb_parvni( 4, 2 ), hb_parvni( 4, 3 ) ), hb_parni( 5 ) );

   iMenu = GetMenu ( hWnd );
   GetMenuInfo(iMenu, &iMenuInfo);
   iMenuInfo.cbSize   = sizeof(MENUINFO);
   if (lSubMenu)
      iMenuInfo.fMask    = MIM_BACKGROUND | MIM_APPLYTOSUBMENUS;
   else
      iMenuInfo.fMask    = MIM_BACKGROUND;

   iMenuInfo.hbrBack = hBrush ;
   SetMenuInfo(iMenu, &iMenuInfo);
   DrawMenuBar( (HWND) HMG_parnl (1) );
}

#pragma ENDDUMP

